Index: trunk/sources/HeuristicLab.ExtLibs.sln
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs.sln	(revision 8616)
+++ trunk/sources/HeuristicLab.ExtLibs.sln	(revision 8617)
@@ -51,5 +51,13 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.LibSVM-3.12", "HeuristicLab.ExtLibs\HeuristicLab.LibSVM\3.12\HeuristicLab.LibSVM-3.12\HeuristicLab.LibSVM-3.12.csproj", "{005C27BE-ED6E-4602-8199-5F9EB7591CEB}"
 EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "WinFormsUI-2.7.0", "HeuristicLab.ExtLibs\HeuristicLab.WinFormsUI\2.7.0\WinFormsUI-2.7.0\WinFormsUI-2.7.0.csproj", "{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.WinFormsUI-2.7.0", "HeuristicLab.ExtLibs\HeuristicLab.WinFormsUI\2.7.0\HeuristicLab.WinFormsUI-2.7.0\HeuristicLab.WinFormsUI-2.7.0.csproj", "{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}"
+EndProject
 Global
+	GlobalSection(SubversionScc) = preSolution
+		Svn-Managed = True
+		Manager = AnkhSVN - Subversion Support for Visual Studio
+	EndGlobalSection
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
 		Debug|Any CPU = Debug|Any CPU
@@ -325,11 +333,31 @@
 		{005C27BE-ED6E-4602-8199-5F9EB7591CEB}.Release|x86.ActiveCfg = Release|x86
 		{005C27BE-ED6E-4602-8199-5F9EB7591CEB}.Release|x86.Build.0 = Release|x86
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Debug|x64.ActiveCfg = Debug|x64
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Debug|x64.Build.0 = Debug|x64
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Debug|x86.ActiveCfg = Debug|x86
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Debug|x86.Build.0 = Debug|x86
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Release|Any CPU.Build.0 = Release|Any CPU
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Release|x64.ActiveCfg = Release|x64
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Release|x64.Build.0 = Release|x64
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Release|x86.ActiveCfg = Release|x86
+		{EAF5F178-406C-4844-B1DC-D3AAF3992FDF}.Release|x86.Build.0 = Release|x86
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Debug|x64.ActiveCfg = Debug|x64
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Debug|x64.Build.0 = Debug|x64
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Debug|x86.ActiveCfg = Debug|x86
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Debug|x86.Build.0 = Debug|x86
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Release|Any CPU.Build.0 = Release|Any CPU
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Release|x64.ActiveCfg = Release|x64
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Release|x64.Build.0 = Release|x64
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Release|x86.ActiveCfg = Release|x86
+		{3A32A015-9BF9-4EEB-AE80-C5E2B654B860}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(SubversionScc) = preSolution
-		Svn-Managed = True
-		Manager = AnkhSVN - Subversion Support for Visual Studio
-	EndGlobalSection
 EndGlobal
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj	(revision 8616)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLab.MainForm.WindowsForms-3.3.csproj	(revision 8617)
@@ -113,7 +113,6 @@
     <Reference Include="System.Data" />
     <Reference Include="System.Xml" />
-    <Reference Include="WeifenLuo.WinFormsUI.Docking-2.3.1, Version=2.3.1.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <HintPath>..\..\bin\WeifenLuo.WinFormsUI.Docking-2.3.1.dll</HintPath>
-      <Private>False</Private>
+    <Reference Include="WeifenLuo.WinFormsUI.Docking-2.7.0, Version=2.7.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <HintPath>..\..\bin\WeifenLuo.WinFormsUI.Docking-2.7.0.dll</HintPath>
     </Reference>
   </ItemGroup>
@@ -263,5 +262,5 @@
   -->
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -270,5 +269,5 @@
 call PreBuildEvent.cmd
 </PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/Plugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/Plugin.cs.frame	(revision 8616)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/Plugin.cs.frame	(revision 8617)
@@ -31,5 +31,5 @@
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.WinFormsUI", "2.3.1")]
+  [PluginDependency("HeuristicLab.WinFormsUI", "2.7")]
   public class HeuristicLabMainFormPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 8616)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 8617)
@@ -115,7 +115,4 @@
     <Reference Include="System.Data" />
     <Reference Include="System.Xml" />
-    <Reference Include="WeifenLuo.WinFormsUI.Docking-2.3.1, Version=2.3.1.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=x86">
-      <Private>False</Private>
-    </Reference>
   </ItemGroup>
   <ItemGroup>
@@ -398,5 +395,5 @@
   -->
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -405,5 +402,5 @@
 call PreBuildEvent.cmd
 </PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)